/*
Copyright 2021 Loft Labs Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1beta1 "github.com/loft-sh/jspolicy/pkg/apis/policy/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeJsPolicyViolationses implements JsPolicyViolationsInterface
type FakeJsPolicyViolationses struct {
	Fake *FakePolicyV1beta1
}

var jspolicyviolationsesResource = schema.GroupVersionResource{Group: "policy.jspolicy.com", Version: "v1beta1", Resource: "jspolicyviolationses"}

var jspolicyviolationsesKind = schema.GroupVersionKind{Group: "policy.jspolicy.com", Version: "v1beta1", Kind: "JsPolicyViolations"}

// Get takes name of the jsPolicyViolations, and returns the corresponding jsPolicyViolations object, and an error if there is any.
func (c *FakeJsPolicyViolationses) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.JsPolicyViolations, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(jspolicyviolationsesResource, name), &v1beta1.JsPolicyViolations{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.JsPolicyViolations), err
}

// List takes label and field selectors, and returns the list of JsPolicyViolationses that match those selectors.
func (c *FakeJsPolicyViolationses) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.JsPolicyViolationsList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(jspolicyviolationsesResource, jspolicyviolationsesKind, opts), &v1beta1.JsPolicyViolationsList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.JsPolicyViolationsList{ListMeta: obj.(*v1beta1.JsPolicyViolationsList).ListMeta}
	for _, item := range obj.(*v1beta1.JsPolicyViolationsList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested jsPolicyViolationses.
func (c *FakeJsPolicyViolationses) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(jspolicyviolationsesResource, opts))
}

// Create takes the representation of a jsPolicyViolations and creates it.  Returns the server's representation of the jsPolicyViolations, and an error, if there is any.
func (c *FakeJsPolicyViolationses) Create(ctx context.Context, jsPolicyViolations *v1beta1.JsPolicyViolations, opts v1.CreateOptions) (result *v1beta1.JsPolicyViolations, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(jspolicyviolationsesResource, jsPolicyViolations), &v1beta1.JsPolicyViolations{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.JsPolicyViolations), err
}

// Update takes the representation of a jsPolicyViolations and updates it. Returns the server's representation of the jsPolicyViolations, and an error, if there is any.
func (c *FakeJsPolicyViolationses) Update(ctx context.Context, jsPolicyViolations *v1beta1.JsPolicyViolations, opts v1.UpdateOptions) (result *v1beta1.JsPolicyViolations, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(jspolicyviolationsesResource, jsPolicyViolations), &v1beta1.JsPolicyViolations{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.JsPolicyViolations), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeJsPolicyViolationses) UpdateStatus(ctx context.Context, jsPolicyViolations *v1beta1.JsPolicyViolations, opts v1.UpdateOptions) (*v1beta1.JsPolicyViolations, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(jspolicyviolationsesResource, "status", jsPolicyViolations), &v1beta1.JsPolicyViolations{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.JsPolicyViolations), err
}

// Delete takes name of the jsPolicyViolations and deletes it. Returns an error if one occurs.
func (c *FakeJsPolicyViolationses) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteAction(jspolicyviolationsesResource, name), &v1beta1.JsPolicyViolations{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeJsPolicyViolationses) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(jspolicyviolationsesResource, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta1.JsPolicyViolationsList{})
	return err
}

// Patch applies the patch and returns the patched jsPolicyViolations.
func (c *FakeJsPolicyViolationses) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.JsPolicyViolations, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(jspolicyviolationsesResource, name, pt, data, subresources...), &v1beta1.JsPolicyViolations{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.JsPolicyViolations), err
}
